
/* Define to prevent recursive inclusion ----------------------------*/
#ifndef __FATFS_H
#define __FATFS_H

 

/* Includes  == ļ --------------------------------------------*/
#include "sys.h"
#include "ff.h"
#include "diskio.h"


#define FONT_ADDR "0:/SYSTEM/GBK16.FON"	//ֿļ·




void FATFS_Get_HzMat(u8 *font, u8 *dzk, u8 size);









/* Private typedef    ==  ˽ ----------------------------------*/
/* Private define     ==  ˽ж ----------------------------------*/

#define FATFS_MAX_FILE_NUM          200    //һĿ¼ļļ
#define FATFS_MAX_LAYER_NUM         10     //ļĿ¼Ƕײ
#define FATFS_MAX_FILE_PATH_NAME    250    //һļ·೤,  /mp3/song/chiansong/Ǳ.MP3
#define FATFS_MAX_FILE_NAME_TOTAL   2048   //һĿ¼ļļܳ

//-----------------------------------------//
typedef struct
{
	//-------------------------------------//
	//ǰĿ¼µļϢ
	u8		FileQuantity;			//ǰĿ¼µļ
	u8		FileNameBuff[FATFS_MAX_FILE_NAME_TOTAL]; 	//ǰĿ¼ȫļŻ棬ÿļ'\0'
	u32		FileNameLen;         	//ǰĿ¼ȫļܳ	
	//-------------------------------------//
	//ǰĿ¼Ϣ
	u8		FilePathName[FATFS_MAX_FILE_PATH_NAME];   	//ǰ·
	u8		FilePathLen;         	//ǰ·
	u8		FileCurNum;     		//ǰѡеļ	
	//-------------------------------------//
	//ǰĿ¼µļϢ
	u8		FileLen[FATFS_MAX_FILE_NUM];     		//ʾNļĳ
	u8		FileType[FATFS_MAX_FILE_NUM];    		//ʾNļ
	u32		FilePostion[FATFS_MAX_FILE_NUM];    	//ʾNļFileNameBuffλ
	u8		FileSongPos[FATFS_MAX_FILE_NUM];    	//ǰĿ¼µĿɲŸܿɲŸλ
	//-------------------------------------//
	//Ŀ¼ǶײϢ
	u8		FileLayerTol;        	//ļ·
	u8		FileLayerNum[FATFS_MAX_LAYER_NUM];   	//ļ·ÿһıѡеļ
	//-------------------------------------//
	//ǰĿ¼ɲŸϢ
	u8		FileCurSongNum;			//ǰֵı
	u8		FileSongAll;			//ǰĿ¼µĿɲŸ
	u8		FileSongNum[FATFS_MAX_FILE_NUM];		//ǰĿ¼µĿɲŸļĿ¼λ
}FATFS_FileListInfoTypeDef;


#define	FATFS_FILEISDIR			0x01
#define	FATFS_FILEISMP3			0x02
#define	FATFS_FILEISWMA			0x03
#define	FATFS_FILEISWAV			0x04
#define	FATFS_FILEISFLAC		0x05
#define	FATFS_FILEISOTHER		0x06



/* Private macro      ==  ˽к ------------------------------------*/
/* Private variables  ==  ˽б ----------------------------------*/



/* Private function prototypes  ==  ˽к --------------------*/
void FATFS_Die(FRESULT rc);
void FATFS_GetChinaDocData(u8 *buff, u8 size, u8 *china);
void FATFS_FileSacn(u8 *path, FATFS_FileListInfoTypeDef *filelist);
void FATFS_DisplayFileName(FATFS_FileListInfoTypeDef *list);
void FATFS_DisplayFileNameBefore(FATFS_FileListInfoTypeDef *list);
void FATFS_DisplayFileNameNext(FATFS_FileListInfoTypeDef *list);
void FATFS_DisplayFileNameBack(FATFS_FileListInfoTypeDef *list);
void FATFS_DisplayFileNameMove(FATFS_FileListInfoTypeDef *list);



/* Define to prevent recursive inclusion ----------------------------*/
#endif /* __FATFS_H */




/*********************************  (C) COPYRIGHT 2014 waft_wind  *********  END OF FILE  **********************************/
