#include "spi.h"
#include "delay.h" 


//129x  	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; 					 
//TF			SPI_InitStructure.SPI_CPOL = SPI_CPOL_High; 					 
					  
void SPI1_Init(void)	
{
	GPIO_InitTypeDef GPIO_InitStructure;   
	SPI_InitTypeDef SPI_InitStructure;	
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1, ENABLE); 
	
	//SCK  PA5  //MISO  PA6	//MOSI  PA7
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;                                                                                                   
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;   
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;    //
  GPIO_Init(GPIOA,&GPIO_InitStructure);              //ʼ
		
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPIģʽ:ΪSPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//SPIݴС:SPIͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; 					  //SCLKΪͣ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;	//ͬʱӵĵڶأ½ݱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		//NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;		//岨ԤƵֵ:ԤƵֵΪ256
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ָݴMSBλLSBλʼ:ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;	//CRCֵĶʽ
	SPI_Init(SPI1,&SPI_InitStructure); 	
	SPI_Cmd(SPI1,ENABLE); //ʹSPI
}


//SPI ٶú
//SPI_BaudRatePrescaler_2   2Ƶ   (SPI 36M@sys 72M)
//SPI_BaudRatePrescaler_8   8Ƶ   (SPI 9M@sys 72M)
//SPI_BaudRatePrescaler_16  16Ƶ  (SPI 4.5M@sys 72M)
//SPI_BaudRatePrescaler_32  32Ƶ  (SPI 2.25M@sys 72M)
//SPI_BaudRatePrescaler_256 256Ƶ (SPI 281.25K@sys 72M)
//SPI1 ٶú
void SPI1_SetSpeed(u8 SpeedSet)
{
  	assert_param(IS_SPI_BAUDRATE_PRESCALER(SpeedSet));
		SPI1->CR1&=0XFFC7;
		SPI1->CR1|=SpeedSet;	//SPI1ٶ 
		SPI_Cmd(SPI1,ENABLE); 
} 

//SPI1 дһֽ
//TxData Ҫдֽ
//ֵ ȡֽ
u8 SPI1_ReadWriteByte(u8 TxData)
{
				u8 retry=0;
				while((SPI1->SR&1<<1)==0)//ָı־λ񣻷ͻձ־λ  
        {
             retry++;
             if(retry>200)return 0;
        }                          
        SPI1->DR=TxData;          //ͨSPIxһbyte
        
				retry=0;				
        while((SPI1->SR&1<<0)==0) //ָı־λ񣻽ջǿձ־λ
        {
             retry++;
             if(retry>200)return 0;
        }                                                             
        return SPI1->DR;          //ͨSPIxյ			
}


void SPI2_Init(void) 
{
 	GPIO_InitTypeDef GPIO_InitStructure;
  SPI_InitTypeDef  SPI_InitStructure;

	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );//PORTBʱʹ 
	RCC_APB1PeriphClockCmd(	RCC_APB1Periph_SPI2,  ENABLE );//SPI2ʱʹ 	
 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //PB13/14/15 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼGPIO
	
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master; 				//ΪSPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; 		//SPI8bit
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High; 					 
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge; 					//ڶʱݱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;							//Ƭѡ
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2; // ʱӷƵ72M/x
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; 		//λǰ
	SPI_InitStructure.SPI_CRCPolynomial = 7; 							//CRCֵĶʽ
 	SPI_Init(SPI2,&SPI_InitStructure); 	

	SPI_Cmd(SPI2, ENABLE); //ʹSPI
}

//SPI ٶú
//SpeedSet:
//SPI_BaudRatePrescaler_2   2Ƶ   
//SPI_BaudRatePrescaler_8   8Ƶ   
//SPI_BaudRatePrescaler_16  16Ƶ  
//SPI_BaudRatePrescaler_256 256Ƶ 
void SPI2_SetSpeed(u8 SPI_BaudRatePrescaler)
{
  assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
	SPI2->CR1&=0XFFC7;
	SPI2->CR1|=SPI_BaudRatePrescaler;	//SPI2ٶ 
	SPI_Cmd(SPI2,ENABLE); 
} 

//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI2_ReadWriteByte(u8 TxData)
{		
	u8 retry=0;				 	
	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}			  
	SPI_I2S_SendData(SPI2, TxData); //ͨSPIxһ
	retry=0;

	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET) //ָSPI־λ:ܻǿձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}	  						    
	return SPI_I2S_ReceiveData(SPI2); //ͨSPIxյ					    
}




