/**
  ******************************************************************************
  * @file    GPIO/IOToggle/stm32f10x_conf.h 
  * @author  MCD Application Team
  * @version V3.5.0
  * @date    08-April-2011
  * @brief   Library configuration file.
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __STM32F10x_CONF_H
#define __STM32F10x_CONF_H

/* Includes ------------------------------------------------------------------*/
/* Uncomment/Comment the line below to enable/disable peripheral header file inclusion */
#include "stm32f10x_adc.h"		//ģת
#include "stm32f10x_bkp.h"		//ݼĴ
//#include "stm32f10x_can.h"		//ģ
//#include "stm32f10x_cec.h"
//#include "stm32f10x_crc.h"		//CRC㵥Ԫ
//#include "stm32f10x_dac.h"		//ģת
//#include "stm32f10x_dbgmcu.h"	//֧
#include "stm32f10x_dma.h"		//ֱڴȡ
#include "stm32f10x_exti.h"		//ⲿж¼
#include "stm32f10x_flash.h"	//洢
//#include "stm32f10x_fsmc.h"		//ľ̬洢
#include "stm32f10x_gpio.h"		//ͨ
//#include "stm32f10x_i2c.h"		//I2Cӿ
//#include "stm32f10x_iwdg.h"		//Ź
#include "stm32f10x_pwr.h"		//Դ/Ŀ
#include "stm32f10x_rcc.h"		//λʱӿ
#include "stm32f10x_rtc.h"		//ʵʱʱ
//#include "stm32f10x_sdio.h"		//SDIOӿ
#include "stm32f10x_spi.h"		//ӿ
#include "stm32f10x_tim.h"		//ʱ
#include "stm32f10x_usart.h"	//ͨͬ/첽շ
//#include "stm32f10x_wwdg.h"		//ڿŹ
#include "misc.h" /* High level functions for NVIC and SysTick (add-on to CMSIS functions) */

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Uncomment the line below to expanse the "assert_param" macro in the 
   Standard Peripheral Library drivers code */
/* #define USE_FULL_ASSERT    1 */

/* Exported macro ------------------------------------------------------------*/
#ifdef  USE_FULL_ASSERT

/**
  * @brief  The assert_param macro is used for function's parameters check.
  * @param  expr: If expr is false, it calls assert_failed function which reports 
  *         the name of the source file and the source line number of the call 
  *         that failed. If expr is true, it returns no value.
  * @retval None
  */
  #define assert_param(expr) ((expr) ? (void)0 : assert_failed((uint8_t *)__FILE__, __LINE__))
/* Exported functions ------------------------------------------------------- */
  void assert_failed(uint8_t* file, uint32_t line);
#else
  #define assert_param(expr) ((void)0)
#endif /* USE_FULL_ASSERT */

#endif /* __STM32F10x_CONF_H */

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
